-- ͻ
--         ۻ  ۻ      ۻ ۻ   ۻ          
--         ͼ  ۻ     ͼ ۻ ͼ          
--         ۻ   ۺ   ۺ     ۻ    ɼ            
--         ͼ   ۺ   ۺ     ͼ    ۻ            
--         ۻ  ɼ ۻ ۻ ɼ ۻ          
--         ͼ  ͼ  ͼ ͼ ͼ   ͼ          
-- Ķ
--         * * *  E U P H O R I A  -  E D I T O R  * * *         
-- Ķ
--  Neues Outfit:  - Deutsche Menfhrung und Kommentare         
--                 - Viele Verbesserungen (z.B. Zeilenanzeige)   
--                                                               
--  Kurzbefehle:   Alle Men-Befehle sind jetzt auch ber die    
--                 Tastatur mit der ALT-Taste verfgbar.         
--                                                               
--  Neue Funktion: Zustzliche Funktionstasten:                  
--                                                               
--                 - ALT-X:  Zeile(n) ausschneiden               
--                 - ALT-C:  Zeile kopieren                      
--                 - Alt-V:  Zeile(n) einfgen                   
-- Ķ
--   DIESE VERSION: MAI 1998, DETLEF REIMERS, DREIMERS@AOL.COM   
-- ͼ
without type_check                               -- luft schneller

include graphics.e
include get.e
include file.e

-- Ŀ
--   DIE KONSTANTEN UND TYPEN  
-- 
constant

TRUE          = 1,                               -- Boolesche Werte
FALSE         = 0,

ESCAPE        = 27,                              -- Zeichen-Codes
OVERRIDE      = 338,
CR            = 13,
BS            = 8,
TAB           = 9,
HOME          = 327,
END           = 335,
ALT_HOME      = 407,
ALT_END       = 415,
PAGE_UP       = 329,
PAGE_DOWN     = 337,
ALT_PG_UP     = 409,
ALT_PG_DOWN   = 417,
HELP          = 291,
NEW           = 305,
OPEN          = 280,
RUN           = 275,
DOS           = 288,
QUIT          = 272,
INSERT        = 303,
SAVE          = 287,
DELETE        = 339,
CUT           = 301,
COPY          = 302,
ACCU_COPY     = 277,
FIND          = 289,
FIND_NEW      = 290,
REPLACE       = 274,
REPLACE_NEW   = 293,
KILL_LINE     = 294,
ZEILE         = 300,
ARROW_LEFT    = 331,
ARROW_RIGHT   = 333,
ALT_ARROW_LFT = 411,
ALT_ARROW_RGT = 413,
ARROW_UP      = 328,
ARROW_DOWN    = 336,
F1            = 315,
F9            = 323,
F10           = 324,
F11           = 389,
F12           = 390,
ALT_DELETE    = 419,           
CONTROL_C     = 3,
N0            = 402,
N1            = 375,
N2            = 397,
N3            = 388,
N4            = 371,
N5            = 399,
N6            = 372,
N7            = 373,
N8            = 401,
N9            = 374,
Np            = 400,
Nm            = 398,
ARR_L         =  17,
ARR_R         =  16,
ARR_T         =  30,
ARR_B         =  31,

-- Ŀ
--  ZEICHEN-CODES FR IBM-GRAPHIK                                
-- 
ASC_HELP      =  F9,
ED_HELP       = F10,
REF_HELP      = F11,
LIB_HELP      = F12,
ASM_HELP      = 286,                             -- ALT-A
BAS_HELP      = 304,                             -- ALT-B
PS_HELP       = 281,                             -- ALT-P
WRUN          = 438,                             -- WINDOW-Taste
HELP_KEY      = {F9, F10, F11, F12},
NEXT_LINE     = HOME & ARROW_DOWN,

-- Ŀ
--  ZEICHEN-CODES FR IBM-GRAPHIK                                
-- 
MODE          = {'O', 'I'},
PROG_INDENT   = 2,                               -- tab = 8 fr andere
A_FILES       = {".asm", ".h"},
B_FILES       = {".bas"},
P_FILES       = {".ps"},
E_FILES       = {".e", ".ex", ".pro"},
T_FILES       = {".pas"},
PROG_FILES    = E_FILES & {".asm", ".h", ".bas", ".ps", "pas"},

TITLE         = {"ASCII.DOC","ED.DOC","REFMAN.DOC","LIBRARY.DOC",
                 "ASM.DOC", "BASIC.DOC", "POST.DOC", "PASCAL.DOC"},

DO_COL_SNTX   = TRUE,                            -- FALSE, wenn kein Syntax
                                                 -- Highlighting gewnscht 
DO_AUTO_CMPL  = TRUE,                            -- FALSE, wenn kein Auto-
                                                 -- Completion gewnscht
HOT_KEYS      = TRUE,                            -- FALSE, wenn nicht immer
                                                 -- nach Befehlen folgen soll

-- Ŀ
--  ZEICHEN-CODES FR IBM-GRAPHIK                                
-- 
IBM_CHAR      = {218, 194, 191, 195, 197, 180, 192, 193, 217, 196, 179,
                 219, 227, 251},

-- Ŀ
--  ZEICHEN-CODES FR CTRL & ZIFFERNBLOCK 1..9, +, -             
-- 
CTRL_CHAR     = {375, 397, 388, 371, 399, 372, 373, 401, 374, 398, 400,
                 402},

CONTROL_CHARS = {ESCAPE, BS, DELETE, PAGE_UP, PAGE_DOWN, CUT, TAB,
                COPY, INSERT, ALT_DELETE, ARROW_LEFT, ARROW_RIGHT, ARROW_UP,
                ARROW_DOWN, ALT_ARROW_LFT, ALT_ARROW_RGT, ACCU_COPY, HOME,
                END, ALT_HOME, ALT_END, SAVE, FIND_NEW, REPLACE_NEW, QUIT,
                N0, N1, N2, N3, N4, N5, N6, N7, N8, N9, Np, Nm,
                HELP, OPEN, NEW, DOS, WRUN, RUN, FIND, REPLACE, ZEILE,
                F1, F1+1, F1+2, F1+3, F1+4, F1+5, F1+6, F1+7, F1+8,
                ASC_HELP, ED_HELP, REF_HELP, LIB_HELP, ASM_HELP, BAS_HELP,
                PS_HELP, OVERRIDE, ARR_L, ARR_R, ARR_T, ARR_B, KILL_LINE,
                ALT_PG_UP, ALT_PG_DOWN},

ED_CURSOR     = UNDERLINE_CURSOR,                -- THICK_UNDERLINE_CURSOR
                                                 -- HALF_BLOCK_CURSOR
                                                 -- BLOCK_CURSOR
    
INITIAL_LINES = 25,                              -- Beim Start des Editor
FINAL_LINES   = 25,                              -- Bei Beendigung des Editors

SCREEN_WIDTH  = 80,

SPECIAL_CHAR  = 254,                             -- Wandle besondere Ctrl
                                                 -- Zeichen in dieses um.
NORM_TAB      = 8,

MAX_WINDOWS   = 8                                -- Auswahl mit F1..F8

-- Ŀ
--  EINSTELLUNG DER FARB-SCHEMATA                                
-- 
global constant C = {0, 1, 0},
--              {1, 0, 0}           {0, 1, 0}             {0, 0, 1}
--              schwarz auf wei    wei auf schwarz      wei auf blau
TOP_TEXT_COL  = C[1]*BRIGHT_WHITE + C[2]*BLACK          + C[3]*BLACK,
TOP_BACK_COL  = C[1]*BLUE         + C[2]*WHITE          + C[3]*WHITE,
TOP_DIM_COL   = C[1]*BRIGHT_RED   + C[2]*RED            + C[3]*RED,
BACK_COL      = C[1]*WHITE        + C[2]*BLACK          + C[3]*BLUE,

FORE_COL      = C[1]*BLACK        + C[2]*WHITE          + C[3]*BRIGHT_WHITE,
COMMENT_COL   = C[1]*RED          + C[2]*YELLOW         + C[3]*BLACK,
KEYWORD_COL   = C[1]*BLUE         + C[2]*BRIGHT_CYAN    + C[3]*BRIGHT_CYAN,
BUILTIN_COL   = C[1]*MAGENTA      + C[2]*BRIGHT_RED     + C[3]*BRIGHT_MAGENTA,
STRING_COL    = C[1]*BRIGHT_WHITE + C[2]*BRIGHT_WHITE   + C[3]*YELLOW,
SPECIAL_COL   = BRIGHT_GREEN,

-- Ŀ
--  FARB-SCHEMA FR KLAMMERN                                     
-- 
BRACKET_COL   = {BRIGHT_CYAN, YELLOW, BRIGHT_GREEN, BRIGHT_WHITE,
                 BRIGHT_MAGENTA},

ex            = 0,
asm           = 1,
bas           = 2,
ps            = 3,
pas           = 4,

SCREEN        = 1,
BLANK_LINE    = repeat(' ', SCREEN_WIDTH)

-- Ŀ
--  GLOBALE DEFINITIONEN FR DEN EDITOR                          
-- 
global object self_command
global sequence f_key

sequence
buffer,       -- Speicher-Puffer, in dem die Datei bearbeitet wird. Dies
              -- ist eine Sequenz, bei der jedes Element eine Sequenz ist,
              -- die eine Text-Zeile enthlt. Jede Textzeile endet mit '\n'.

file_name,    -- Name der Datei, die editiert wird.

window_list,  -- Status-Info fr alle Fenster
buffer_list,  -- Alle Puffer
hlp           -- Hilfe-Fenster-Flags

window_list   = {0}
buffer_list   = {}

-- Ŀ
--  TYPEN-DEFINITIONEN UND ANDERES...                            
-- 
type boolean(integer x)
  return x = TRUE or x = FALSE
end type

type natural(integer x)
  return x >= 0
end type

type positive_int(integer x)
  return x >= 1
end type

-- 
integer
ins,                    -- Einfgen/berschreiben-Flag (insert/override)
first_copy              -- copy-/append copy-Flag

positive_int
screen_length,          -- Anzahl der Bildschirmzeilen
window_length,          -- Anzahl der Textzeilen im aktuellen Fenster
window_base             -- Position der ersten Zeile des jetzigen Fensters

window_base   = 1       -- (Status-Zeile)

-- 
type window_id(integer x)
  return x >= 1 and x <= length(window_list)
end type

type buffer_id(integer x)
  return x >= 0 and x <= length(buffer_list)
end type

type window_line(integer x)  -- eine gltige Zeile im jetzigen Fenster
  return x >= 1 and x <= window_length
end type

type screen_col(integer x)   -- eine gltige Spalte auf dem Bildschirm
  return x >= 1 and x <= SCREEN_WIDTH
end type

type buffer_line(integer x)  -- eine gltige Puffer-Zeile
  return (x >= 1 and x <= length(buffer)) or x = 1
end type

type char(integer x)         -- ein Zeichen (incl. spezieller Tasten-Codes)
  return x >= 0 and x <= 511
end type

type extended_char(integer x)
  return char(x) or x = -1
end type

type file_number(integer x)
  return x >= -1
end type

-- Ŀ
--  WICHTIGE DATENSTRUKTUREN FR DEN EDITOR-PUFFER               
-- 
buffer_line  b_line             -- Aktuelle Puffer-Zeile
positive_int b_col              -- Aktuelles Zeichen in der Puffer-Zeile
window_line  s_line             -- Bildschirmzeile, die b_line entspricht
screen_col   s_col              -- Bildschirmspalte, die b_col entspricht

boolean
stop,                           -- Beende Bearbeitung des jetzigen Puffers
adding_to_kill,                 -- TRUE beim Sammeln gelschter Zeil/Zeich
multi_color,                    -- Benutze Farbe fr Keywords usw.
auto_complete,                  -- Fhre Auto-Completion von Befehlen durch
dot_e,                          -- TRUE, wenn .e-/.ex-Datei vorliegt
modified,                       -- TRUE if file has been modified
control_chars                   -- Binrdatei - nur Ansehen, kein Speichern
         
atom
buffer_version,                 -- Version des Puffer-Inhalts
my_buffer_version               -- Letzte Version, vom jetzigen Fenster benutzt

natural
start_line,
start_col

window_id window_number         -- Aktuelles, aktives Fenster
window_number      = 1

buffer_id buffer_number         -- Aktuelles, aktiver Puffer
buffer_number      = 0

sequence
kill_buffer,                    -- Lsch-Puffer aus gelschten Zeilen/Zeichen
error_message,
config,                         -- Video-Konfiguration
key_queue                       -- Queue von Eingabe-Zeichen, von ed erzeugt
kill_buffer        = {}
key_queue          = {}

global atom lang
lang               = 0

-- Ŀ
--   DIE PROZEDUREN UND FUNKTIONEN  
-- 

-- Ŀ
--  Berechne die Anzahl der Ziffern einer Zahl.                 
--  Wird fr die Zeilen/Spalten-Anzeige bentigt.               
-- 
function digits(atom x)

  x = floor(log(x)/log(10)) + 1
  return x

end function

-- Ŀ
--  Eine Pause von n Sekunden                                   
-- 
procedure delay(atom n)
  
  atom t
  t = time()

  while time() < t + n do
  end while

end procedure

-- Ŀ
--  Puffer und Datei sind verschieden                           
-- 
procedure set_modified()

  modified = TRUE
  cursor(NO_CURSOR)
  
  buffer_version = buffer_version + 1

end procedure

-- Ŀ
--  Puffer und Datei sind identisch                             
-- 
procedure clear_modified()

  modified = FALSE

end procedure

-- Ŀ
--  Konvertiere die relative Position im Fenster in absolute    
--  Bildschirm-Positionen. 'window_line 0' ist die Statuszeile, 
--  'window_line 1' ist die erste Textzeile.                    
-- 
procedure set_position(natural window_line, positive_int column)
  
  position(window_base + window_line, column)

end procedure

natural edit_tab_width 

-- Ŀ
--  Bestimme neue Spalten-Position nach TAB                     
-- 
function tab(natural tab_width, positive_int pos)
  
  return (floor((pos - 1) / tab_width) + 1) * tab_width + 1

end function

-- Ŀ
--  Ersetze in einer Textzeile Tabs durch Leerzeichen.          
-- 
function expand_tabs(natural tab_width, sequence line)

  natural tab_pos, column, ntabs
  column = 1
 
  while TRUE do
    tab_pos = find('\t', line[column..length(line)])
    
    if tab_pos = 0 then
      return line                                -- keine weiteren Tanbs
    else
      tab_pos = tab_pos + column - 1
    end if
    
    column = tab(tab_width, tab_pos)
    ntabs = 1
    
    while line[tab_pos+ntabs] = '\t' do
      ntabs = ntabs + 1
      column = column + tab_width
    end while
    
    line = line[1..tab_pos-1] &                  -- Ersetze Mehrfach-Tabs
    repeat(' ', column - tab_pos) & line[tab_pos+ntabs..length(line)]
  end while

end function

-- Ŀ
--  Erst hier INCLUDE syncolor, da die Datenstrukturen vorher    
--  definiert sein mssen.                                       
-- 
include syncolor.e

-- Ŀ
--  Starte inverse Video-Darstellung                            
-- 
procedure reverse_video()
    
  text_color(TOP_TEXT_COL)
  bk_color(TOP_BACK_COL)

end procedure

-- Ŀ
--  Beende inverse Vidoe-Darstellung                            
-- 
procedure normal_video()
    
  text_color(FORE_COL)
  bk_color(BACK_COL)

end procedure

-- Ŀ
--  Lsche aktuelle Bildschirm-Zeile                            
-- 
procedure ClearLine(window_line sline)
    
  scroll(1, window_base + sline, window_base + sline)

end procedure

-- Ŀ
--  Lsche das aktuelle Fenster                                 
-- 
procedure ClearWindow()

  scroll(window_length, window_base+1, window_base+window_length)

end procedure

-- Ŀ
--  Bewege den Text auf dem Bildschirm eine Zeile nach oben     
-- 
procedure ScrollUp(positive_int top, positive_int bottom)
    
  scroll(+1, window_base + top, window_base + bottom)

end procedure

-- Ŀ
--  Bewege den Text auf dem Bildschirm eine Zeile nach unten    
-- 
procedure ScrollDown(positive_int top, positive_int bottom)
    
  scroll(-1, window_base + top, window_base + bottom)

end procedure

-- Ŀ
--  Zeige eine Pufferzeile in einer speziellen Bilschirmzeile   
-- 
procedure DisplayLine(buffer_line bline, window_line sline, boolean all_clear)

  sequence this_line
  natural last
    
  this_line = expand_tabs(edit_tab_width, buffer[bline])
  last = length(this_line) - 1
  set_position(sline, 1)
  
  if multi_color then
    DisplayColorLine(this_line)                  -- Farbige Anzeige
  else
    puts(SCREEN, this_line[1..last])             -- Monochrome Anzeige
  end if
  
  if last > SCREEN_WIDTH then
    set_position(sline, SCREEN_WIDTH)            -- setze Zeile zu lang
    text_color(BACK_COL)
    bk_color(FORE_COL)
    puts(SCREEN, this_line[SCREEN_WIDTH])
    normal_video()
  elsif not all_clear then
    puts(SCREEN, BLANK_LINE)
  end if

end procedure

-- Ŀ
--  Bringe eine Reihe von Pufferzeilen - beginnend bei sline -  
--  auf den Bildschirm. Fahre solange damit fort, bis das Ende  
--  des Bildschirms oder das Ende des Puffers erreicht ist.     
-- 
procedure DisplayWindow(positive_int bline, window_line sline)

  boolean all_clear

  if sline = 1 then
    ClearWindow()
    all_clear = TRUE
  else
    all_clear = FALSE
  end if

  for b = bline to length(buffer) do
    DisplayLine(b, sline, all_clear)
    if sline = window_length then
      return
    else
      sline = sline + 1
    end if
  end for

  -- lsche alle restlichen Bildschirmzeilen nach dem Dateiende

  for s = sline to window_length do
    ClearLine(s)
  end for

end procedure

-- Ŀ
--  Ersetze Control-Zeichen durch Graphik-Zeichen               
-- 
function clean(sequence line)

  integer c

  for i = 1 to length(line) do
    c = line[i]
    if c < 14 then
      if c != '\n' then
        if c != '\t' then
          line[i] = SPECIAL_CHAR
          control_chars = TRUE
        end if
      end if
    end if
  end for
  
  if line[length(line)] != '\n' then
    line = line & '\n'
  end if

  return line

end function

-- Ŀ
--  Fge eine neue Zeile in den Puffer ein.                     
-- 
function add_line(file_number file_no)

  object line
  line = gets(file_no)

  if atom(line) then
    return FALSE                                 -- Dateiende
  end if

  line = clean(line)
  buffer = append(buffer, line)
  return TRUE

end function

-- Ŀ
--  Mache Platz fr einen neuen (leeren) Puffer.                
--  'buffer_list' ist der Platzhalter.                          
-- 
procedure new_buffer()

  buffer_list = buffer_list & 0
  buffer_number = length(buffer_list)
  buffer = {}

end procedure

-- Ŀ
--  Lies die gesamte Datei in die Puffer-Variable. Zeige sofort 
--  den ersten Bildschirm-Inhalt beim Einlesen.                 
-- 
procedure read_file(file_number file_no)
    
  for i = 1 to window_length do
    if not add_line(file_no) then
      exit
    end if
  end for
  
  DisplayWindow(1, 1)

  while add_line(file_no) do
  end while

end procedure

-- Ŀ
--  Zeige rechts oben die aktuelle Zeile und Spalte an.         
-- 
procedure show_row_col()

  reverse_video()
  set_position(0,SCREEN_WIDTH - digits(b_line) - digits(s_col) - 10)
  printf(SCREEN, "     [%d,%d]",{b_line,s_col})
  text_color(TOP_DIM_COL)
  set_position(0,SCREEN_WIDTH - 1)
  printf(SCREEN, "%s",{MODE[ins+1]})
  normal_video()
  set_position(s_line,s_col)

end procedure

-- Ŀ
--  Zeige Dateinamen und Zeile/Spalte in der Kopfzeile an.      
-- 
procedure reset_top_line(boolean pos)

  set_position(0, 1)
  reverse_video()

  puts(SCREEN, ' ' & f_key & file_name & BLANK_LINE)
  set_position(0,SCREEN_WIDTH - digits(b_line) - digits(s_col) - 10)
  printf(SCREEN, "     [%d,%d]",{b_line,s_col})
  text_color(TOP_DIM_COL)
  set_position(0,SCREEN_WIDTH - 1)
  printf(SCREEN, "%s",{MODE[ins+1]})
  normal_video()
  
  if pos then
    set_position(s_line,s_col)
  end if

end procedure

-- Ŀ
--  Zeige eine Meldung in der Kopfzeile an.                     
-- 
procedure set_top_line(sequence message)

  set_position(0, 1)
  reverse_video()
  puts(SCREEN, message & BLANK_LINE)
  set_position(0, length(message)+1)

end procedure

-- Ŀ
--  Aktion fr Tab-Taste im berschreib-Modus (nur Bewegen).    
-- 
procedure tab_right()
    
  positive_int temp_col

  if b_col < length(buffer[b_line]) then
    temp_col = tab(edit_tab_width, s_col)
    if temp_col > SCREEN_WIDTH then
      return
    end if
    s_col = temp_col
    b_col = s_col
  end if

end procedure

-- Ŀ
--  Aktion fr Pfeil-Rechts-Taste.                              
-- 
procedure arrow_right()
    
  positive_int temp_col

  if b_col < length(buffer[b_line]) then
    if buffer[b_line][b_col] = '\t' then
      temp_col = tab(edit_tab_width, s_col)
    else
      temp_col = s_col + 1
    end if
    if temp_col > SCREEN_WIDTH then
      return
    end if
    s_col = temp_col
    b_col = b_col + 1
  end if

end procedure

-- Ŀ
--  Aktion fr Pfeil-Links-Taste.                               
-- 
procedure arrow_left()
    
  positive_int old_b_col
  old_b_col = b_col
  b_col = 1
  s_col = 1
  
  for i = 1 to old_b_col - 2 do
    arrow_right()
  end for

end procedure
  
-- Ŀ
--  Setze den Cursor auf das erste nichtleere Zeichen der Zeile 
-- 
procedure skip_white()

  positive_int temp_col
    
  while find(buffer[b_line][b_col], " \t") do
    temp_col = s_col
    arrow_right()
    if s_col = temp_col then
      return               
    end if
  end while

end procedure

-- Ŀ
--  Gehe zur angegebenen Zeile und Spalte.                      
--  Erneuere den Bildschirm, falls die Zeile Null ist.          
-- 
procedure goto_line(integer new_line, integer new_col)

  integer new_s_line
  boolean refresh

  if length(buffer) = 0 then
    ClearWindow()
    s_line = 1
    s_col = 1
    return
  end if

  if new_line = 0 then
    new_line = b_line
    refresh = TRUE
  else
    refresh = FALSE
  end if

  if new_line < 1 then
    new_line = 1
  elsif new_line > length(buffer) then
    new_line = length(buffer)
  end if

  new_s_line = new_line - b_line + s_line
  b_line = new_line

  if not refresh and window_line(new_s_line) then
    
    -- Neue Zeile ist innerhalb des Bildschirms
    
    s_line = new_s_line
  
  else
    
    -- Neue Zeile ist auerhalb des Bildschirms oder Update
  
    set_position(1, 1)
    s_line = floor((window_length+1)/2)
    
    if s_line > b_line or length(buffer) < window_length then
      s_line = b_line
    elsif b_line > length(buffer) - window_length + s_line then
      s_line = window_length - (length(buffer) - b_line)
    end if
    
    DisplayWindow(b_line - s_line + 1, 1)
  
  end if

  b_col = 1
  s_col = 1
  set_position(s_line, s_col)

  for i = 1 to new_col-1 do
    arrow_right()
  end for

end procedure

-- Ŀ
--  Definiert den Text fr 'next_word' und 'previous_word'.     
-- 
function plain_text(char c)
    
  return (c >= '0' and c <= '9') or
   (c >= 'A' and c <= 'Z') or
   (c >= 'a' and c <= 'z') or
     c = '_'

end function

-- Ŀ
--  Gehe zum nchsten Wort in der Zeile.                        
-- 
procedure next_word()
    
  char c
  positive_int col
  
  col = b_col
  
  while TRUE do
    c = buffer[b_line][col]
    if not plain_text(c) then
      exit
    end if
    col = col + 1
  end while

  while c != '\n' do                             -- bergehe Leerzeichen
    c = buffer[b_line][col]                      -- und Punktuation
    if plain_text(c) then
      exit
    end if
    col = col + 1
  end while
  
  goto_line(b_line, col)

end procedure

-- Ŀ
--  Gehe zum Beginn des letzten Wortes in dieser Zeile          
-- 
procedure previous_word()
    
  char c
  natural col

  col = b_col - 1
  
  while col > 1 do                               -- bergehe Leerzeichen
    c = buffer[b_line][col]                      -- und Punktuation
    if plain_text(c) then
      exit
    end if
    col = col - 1
  end while

  while col > 1 do                               -- bergehe normalen Text
    c = buffer[b_line][col-1]
    if not plain_text(c) then
      exit
    end if
    col = col - 1
  end while

  goto_line(b_line, col)

end procedure

-- Ŀ
--  Aktion fr Pfeil-Hoch-Taste                                 
-- 
procedure arrow_up()
    
  b_col = 1
  s_col = 1

  if b_line > 1 then
    
    b_line = b_line - 1
    
    if s_line > 1 then
      s_line = s_line - 1
    else
      ScrollDown(1, window_length)               -- Alle Zeilen nach unten
      DisplayLine(b_line, 1, TRUE)               -- Neue Zeile oben zeigen
      set_position(1, 1)
      s_line = 1
    end if
    
    skip_white()
  
  end if

end procedure

-- Ŀ
--  Aktion fr Pfeil-Tief-Taste                                 
-- 
procedure arrow_down()
    
  b_col = 1
  s_col = 1

  if b_line < length(buffer) then
    b_line = b_line + 1
    
    if s_line < window_length then
      s_line = s_line + 1
    else
      ScrollUp(1, window_length)                 -- Alle Zeilen nach oben
      DisplayLine(b_line, window_length, TRUE)   -- Neue Zeile unten zeigen
    end if
    
    skip_white()
  
  end if

end procedure

-- Ŀ
--  Konvertiere einen Zahlenstring in eine Ganzzahl.            
-- 
function numeric(sequence string)
    
  atom n
  n = 0

  for i = 1 to length(string) do
    
    if string[i] >= '0' and string[i] <= '9' then
      n = n * 10 + string[i] - '0'
      if not integer(n) then
        return 0
      end if
    else
      exit
    end if
  
  end for

  return n

end function

-- Ŀ
--  Aktion fr Nchste-Seite-Taste.                             
-- 
procedure page_down()
    
  buffer_line prev_b_line

  if length(buffer) <= window_length then
    return
  end if

  prev_b_line = b_line
  b_col = 1
  s_col = 1

  if b_line + window_length + window_length - s_line <= length(buffer) then
    b_line = b_line + window_length
  else
    b_line = length(buffer) - (window_length - s_line)
  end if

  if b_line != prev_b_line then
    DisplayWindow(b_line - s_line + 1, 1)
  end if

end procedure

-- Ŀ
--  Aktion fr Vorige Seite-Taste.                              
-- 
procedure page_up()
    
  buffer_line prev_b_line

  if length(buffer) <= window_length then
    return
  end if

  prev_b_line = b_line
  b_col = 1
  s_col = 1

  if b_line - window_length >= s_line then
    b_line = b_line - window_length
  else
    b_line = s_line
  end if

  if b_line != prev_b_line then
    DisplayWindow(b_line - s_line + 1, 1)
  end if

end procedure

-- Ŀ
--  Zeige F-Key und Dateinamen in der Kopfzeile.                
-- 
procedure set_f_line(natural w)
    
  if length(window_list) = 1 then
    f_key = ""
  else
    f_key = 'F' & ('0' + w) & " "
  end if

  reset_top_line(FALSE)

end procedure

-- Ŀ
--  Fenster- und Puffer-Variablen                                
-- 
constant

W_BUFFER_NUMBER         = 1,
W_MY_BUFFER_VERSION     = 2,
W_WINDOW_BASE           = 3,
W_WINDOW_LENGTH         = 4,
W_B_LINE                = 10

-- Ŀ
--  Sichere aktuelle Status-Variablen fr ein Fenster.          
-- 
procedure save_state()
    
  window_list[window_number] = {buffer_number, buffer_version, window_base,
        window_length, auto_complete, multi_color,
        dot_e, control_chars, file_name, b_line,
        b_col, s_line, s_col, edit_tab_width, lang}
  buffer_list[buffer_number] = {buffer, modified, buffer_version}

end procedure

-- Ŀ
--  Setze Status-Variablen eines Fenster auf alte Werte zurck  
-- 
procedure restore_state(window_id w)
    
  sequence state
  sequence buffer_info

  state = window_list[w]                         -- Erzeuge neuen Puffer
  window_number = w
  buffer_number =  state[W_BUFFER_NUMBER]
  buffer_info = buffer_list[buffer_number]
  buffer = buffer_info[1]
  modified = buffer_info[2]
  buffer_version = buffer_info[3]
  buffer_list[buffer_number] = 0                 -- Platz sparen

  my_buffer_version = state[2]                   -- Setze die brigen
  window_base = state[3]                         -- Variablen zurck
  window_length = state[4]
  auto_complete = state[5]
  multi_color = state[6]
  dot_e = state[7]
  control_chars = state[8]
  file_name = state[9]
  edit_tab_width = state[14]
  lang = state[15]
  set_f_line(w)
  normal_video()

  if buffer_version != my_buffer_version then

    -- Der Puffer oder die Fenstergre hat sich verndert,
    -- seit wir uns zum letzten mal in diesem Fenster befanden.

    if state[W_B_LINE] > length(buffer) then
      if length(buffer) = 0 then
  b_line = 1
      else
  b_line = length(buffer)
      end if
    else
      b_line = state[W_B_LINE]
    end if
    
    goto_line(0, 1)
  
  else
    
    b_line = state[W_B_LINE]
    b_col = state[11]
    s_line = state[12]
    s_col = state[13]
    set_position(s_line, s_col)
  
  end if

end procedure

-- Ŀ
--  Baue alle Fenster auer w neu auf.                          
-- 
procedure refresh_other_windows(positive_int w)
    
  normal_video()

  for i = 1 to length(window_list) do
    if i != w then
      restore_state(i)
      set_f_line(i)
      normal_video()
      goto_line(0, b_col)
      save_state()
    end if
  end for

end procedure

-- Ŀ
--  Setze die Fenstergren                                     
-- 
procedure set_window_size()
    
  natural nwindows                              -- lines, base, size
  nwindows = length(window_list)

  for i = 1 to length(window_list) do
    window_list[i][W_WINDOW_BASE]       = 1
    window_list[i][W_WINDOW_LENGTH]     = 24
    window_list[i][W_MY_BUFFER_VERSION] = -1     -- erzwinge Update
    nwindows = nwindows - 1
  end for

end procedure

-- Ŀ
--  Sichere den Status des aktuellen Fensters und erzeuge ein   
--  neues Fenster als Clone des aktuellen Fensters              
-- 
procedure clone_window()
    
  window_id w

  if length(window_list) >= MAX_WINDOWS then
    return
  end if

  save_state()

  window_list = window_list[1..window_number] &  -- Platz fr neues Fenster
               {window_list[window_number]} &    -- das neue Clone-Fenster
                window_list[window_number+1..length(window_list)]

  w = window_number + 1
  set_window_size()
  
  -- refresh_other_windows(w)                   -- von mir deaktiviert !!!
  
  restore_state(w)

end procedure

-- Ŀ
--  Wechsle den Kontext zu einem neuen Biuldschirm-Fenster      
-- 
procedure switch_window(integer new_window_number)

  if new_window_number != window_number then
    save_state()
    restore_state(new_window_number)
  end if

  set_keywords()
  DisplayWindow(b_line - s_line + 1, 1)

end procedure

-- Ŀ
--  Lsche das aktuelle Fenster                                 
-- 
function delete_window()
    
  boolean buff_in_use

  buffer_list[buffer_number] = {buffer, modified, buffer_version}
  window_list = window_list[1..window_number-1] &
                window_list[window_number+1..length(window_list)]
  buff_in_use = FALSE

  for i = 1 to length(window_list) do
    if window_list[i][W_BUFFER_NUMBER] = buffer_number then
      buff_in_use = TRUE
      exit
    end if
  end for

  if not buff_in_use then
    buffer_list[buffer_number] = 0             -- Entferne den Puffer
  end if

  if length(window_list) = 0 then
    return TRUE
  end if

  set_window_size()
  refresh_other_windows(1)
  window_number = 1
  restore_state(window_number)
  set_position(s_line, s_col)
  return FALSE

end function

-- Ŀ
--  Fge Tastenbefehl dem Queue beliebiger Tastenbefehle hinzu. 
-- 
procedure add_queue(sequence keystrokes)
    
  key_queue = key_queue & keystrokes

end procedure

-- Ŀ
--  Gib den nchsten Tastendruck des Benutzers zurck, oder     
--  von unserem Tasten-Queue. Prfe auf Control-C               
-- 
function next_key()
    
  char c
    
  if length(key_queue) then
    -- Lies nchsten beliebigen Tastenbefehl
    c = key_queue[1]
    key_queue = key_queue[2..length(key_queue)]
  else
    -- Lies neuen Tastenbefehl vom Benutzer
    c = wait_key()
    if check_break() then
      c = CONTROL_C
    end if
  end if
  
  return c

end function

-- Ŀ
--  Aktualisiere alle Fenster                                   
-- 
procedure refresh_all_windows()
    
  window_id w
  w = window_number
  save_state()
  refresh_other_windows(w)
  restore_state(w)

end procedure

-- Ŀ
--  Gib den von der Tastatur einggebenen String zurck: ein     
--  bichen benutzerfreundlicher als gets(0).                   
-- 
function key_gets(sequence hot_keys)
   
  sequence input_string
  integer line, init_column, column, char
  sequence cursor

  if not HOT_KEYS then
    hot_keys = ""
  end if

  cursor = get_position()
  line = cursor[1]
  init_column = cursor[2]
  column = init_column
  input_string = ""

  while TRUE do
    char = next_key()

    if char = CR or char = ESCAPE then
      exit

    elsif char = BS or char = ARROW_LEFT then
      if column > init_column then
        column = column - 1
        position(line, column)
        puts(SCREEN, ' ')
        position(line, column)
        input_string = input_string[1..length(input_string)-1]
      end if

    elsif (char >= 32 and char <= 255) or char = '\t' then
      if column < SCREEN_WIDTH then
  
  if char = '\t' then
    puts(SCREEN, ' ')
  else
    puts(SCREEN, char)
  end if
  
  column = column + 1
  
  if column - init_column > length(input_string) then
    input_string = append(input_string, char)
    if column = init_column + 1 and find(char, hot_keys) then
      exit
    end if
  else
    input_string[column - init_column] = char
  end if
      
      end if

    elsif char = CONTROL_C then
      
      refresh_all_windows()                      -- Erneuere Bildschirm,
      goto_line(0, b_col)                        -- wie <ENT> behandeln
      input_string = input_string & CR
      exit
    
    end if
  end while

  return input_string

end function

-- Ŀ
--  Variablen fr das Suchen und Ersetzen                        
-- 
boolean
searching,
replacing,
match_case

searching = FALSE
replacing = FALSE
match_case = TRUE

sequence find_string            -- der jetzige (default) Suche-String
find_string = ""

sequence replace_string         -- der jetzige (default) Ersetze-String
replace_string = ""


-- Ŀ
--  Erstze find_strind durch replace_string. Wir befinden uns   
--  augenblicklich am Anfang eines gefundenen find_string.      
-- 
procedure replace()

  sequence line

  set_modified()
  line = buffer[b_line]
  line = line[1..b_col-1] & replace_string &
         line[b_col+length(find_string)..length(line)]
  buffer[b_line] = line

  for i = 1 to length(replace_string)-1 do       -- Position am Ende
    arrow_right()                                -- des Ersetze-Strings
  end for

  DisplayLine(b_line, s_line, FALSE)

end procedure

-- Ŀ
--  Konvertiere zu Kleinschreibung                              
-- 
function lower(sequence s)
    
  integer c
  for i = 1 to length(s) do
    c = s[i]
    if c >= 'A' then
      if c <= 'Z' then
        s[i] = c + 'a' - 'A'
      end if
    end if
  end for

  return s

end function

-- Ŀ
--  Enthlt s alphabetische Zeichen?                            
-- 
function alphabetic(object s)
    
  return find(TRUE, (s >= 'A' and s <= 'Z') or
  (s >= 'a' and s <= 'z'))

end function

-- Ŀ
--  Finde einen String im Text mit oder ohne Fall.              
-- 
function case_match(sequence string, sequence text)
    
  if match_case then
    return match(string, text)
  else
    return match(lower(string), lower(text))
  end if

end function

-- Ŀ
--  Finde einen String von dieser Position bis zum Dateiende.   
--  Gib 'TRUE' zurck, falls der String gefunden wurde.         
-- 
function search(boolean continue)
    
  natural col
  sequence temp_find_string, temp_replace_string
  sequence pos

  set_top_line("")

  if length(buffer) = 0 then
    puts(SCREEN, " Kein Text")
    return FALSE
  end if

  if length(find_string) = 0 then
    puts(SCREEN, " Finde >")
  else
    printf(SCREEN, " Finde \"%s\" >", {find_string})
  end if

  if not continue then
    pos = get_position()
    temp_find_string = key_gets("")

    if length(temp_find_string) > 0 then         -- Neu eingegebener String
      find_string = temp_find_string

      if alphabetic(find_string) then
        set_position(0, pos[2]+length(temp_find_string)+3)
        puts(SCREEN, "mit Fall (n)? ")
        pos = get_position()
        set_position(0, pos[2] - 1)
        match_case = find('j', key_gets("jn"))
      end if
    
    end if

    if replacing then
      set_top_line("")

      if length(replace_string) = 0 then
        puts(SCREEN, " Ersetze durch >")
      else
        printf(SCREEN, " Ersetze durch \"%s\" >", {replace_string})
      end if

      temp_replace_string = key_gets("")

      --if length(temp_replace_string) > 0 then  -- von mir gendert !!!
        replace_string = temp_replace_string
      --end if                                   -- von mir gendert !!!
    
    end if
  end if

  reset_top_line(FALSE)
  normal_video()

  if length(find_string) = 0 then
    return FALSE
  end if

  col = case_match(find_string, buffer[b_line][b_col+1..length(buffer[b_line])])

  if col and s_col < SCREEN_WIDTH then
    
    -- In dieser Zeile hinter der aktuellen Position gefunden

    for i = 1 to col do
      arrow_right()
    end for
    
    if replacing then
      replace()
    end if
    
    return TRUE
  else
    
    for b = b_line+1 to length(buffer) do        -- berprfe alle noch
      col = case_match(find_string, buffer[b])   -- folgenden Zeilen
      
      if col then
        goto_line(b, 1)
  
        for i = 1 to col - 1 do
          arrow_right()
        end for
  
        if replacing and s_col < SCREEN_WIDTH then
          replace()
        end if
  
        return TRUE
      end if
    end for

    set_top_line("")
    printf(SCREEN, " \"%s\" nicht gefunden.", {find_string})
    delay(0.4)
  
  end if

  reset_top_line(FALSE)
  return FALSE

end function

-- Ŀ
--  Zeige die Fehlermeldung von 'ex.err' an.                    
-- 
procedure show_message()
    
  if length(error_message) > 0 then
    set_top_line("")
    puts(SCREEN, error_message)
    delay(0.2)
    reset_top_line(TRUE)
  end if

end procedure

-- Ŀ
--  Setze den Cursor an die Fehlerposition.                     
-- 
procedure set_err_pointer()
    
  for i = 1 to SCREEN_WIDTH do
    
    if s_col >= start_col then
      exit
    end if
    
    arrow_right()
  end for

end procedure

-- Ŀ
--  Lsche Leerzeichen, Tab's und CR's am Ende des Strings.     
-- 
function delete_trailing_white(sequence name)

  while length(name) > 0 do
    if find(name[length(name)], "\n\r\t ") then
      name = name[1..length(name)-1]
    else
      exit
    end if
  end while

  return name

end function

-- Ŀ
--  Versuche, den Dateinamen und die Zeilennummer von ex.err    
--  zu holen. Gibt file_name zurck, setzt start_line,          
--  start_col und error_message.                                
-- 
function get_err_line()

  file_number err_file
  sequence file_name
  sequence err_lines
  object temp_line
  natural colon_pos

  err_file = open("ex.err", "r")

  if err_file = -1 then
    error_message = ""
  else
    
    -- Lies den Anfang der Datei ex.err
    
    err_lines = {}
    
    while length(err_lines) < 5 do
      temp_line = gets(err_file)
      if atom(temp_line) then
        exit
      end if
      err_lines = append(err_lines, temp_line)
    end while
    
    close(err_file)
    
    -- Suche nach Dateinamen, Zeile, Spalte und Fehlermeldung
    
    if length(err_lines) > 0 then
      if sequence(err_lines[1]) then
        colon_pos = match(".e", lower(err_lines[1]))
        if colon_pos then
    
          if find(err_lines[1][colon_pos+2],{'x', 'X'}) then
            colon_pos = colon_pos + 1
          end if
    
          file_name = err_lines[1][1..colon_pos+1]
          start_line = numeric(err_lines[1][colon_pos+3..
          length(err_lines[1])])
          error_message = delete_trailing_white(err_lines[2])
    
          if length(err_lines) > 3 then
            start_col = find('^', expand_tabs(NORM_TAB,
            err_lines[length(err_lines)-1]))
          end if
    
          return file_name
        end if
      end if
    end if
  end if

  return ""

end function

-- Ŀ
--  Git TRUE zurck, falls der aktuelle Puffer nur auf das      
--  aktuelle Fenster verweist.                                  
-- 
function last_use()

  natural count

  count = 0
  
  for i = 1 to length(window_list) do
    if window_list[i][W_BUFFER_NUMBER] = buffer_number then
      count = count + 1
      
      if count = 2 then
        return FALSE
      end if
    
    end if
  end for

  return TRUE

end function

-- Ŀ
--  Schreibe den Puffer zurck in die Datei.                    
-- 
procedure save_file(sequence file_name)
    
  file_number file_no

  --if control_chars then                        -- Von mir deaktiviert !!!
    --set_top_line("")                           -- Nicht erwnscht !
    --printf(SCREEN, " %s: Cntrl-Zeichen gendert in " & SPECIAL_CHAR &
                  --" - trotzdem sichern? >", {file_name})
    
    --if not find('j', key_gets("jn")) then
      --stop = FALSE
      --return
    --end if
  
  --end if

  set_top_line("")
  file_no = open(file_name, "w")

  if file_no = -1 then
    printf(SCREEN, " %s kann nicht gesichert werden.", {file_name})
    stop = FALSE
    return
  end if

  printf(SCREEN, " Sichere %s... ", {file_name})

  for i = 1 to length(buffer) do
    puts(file_no,expand_tabs(edit_tab_width, buffer[i]))
  end for

  close(file_no)
  reset_top_line(FALSE)
  clear_modified()
  stop = TRUE

end procedure

-- Ŀ
--  Fhre einen DOS-Befehl aus.                                 
-- 
procedure shell(sequence command, boolean wait)

  sequence  pal

  if length(command) then
    bk_color(BLACK)
    text_color(WHITE)
    clear_screen()
    system(command, wait)
    normal_video()
    pal = palette(BLUE,{0,23,35})

    while get_key() != -1 do                     -- Lsche den Tastatur-Puffer
    end while

  end if

  refresh_all_windows()
  
end procedure

-- Ŀ
--  Fhre den aktuellen Befehl aus und gehe zurck.             
-- 
procedure run_ex()

  if modified then
    save_file(file_name)
    stop = FALSE
  end if

  if sequence(dir("ex.err")) then
    system("del ex.err > NUL", 0)
  end if

  shell("EX " & file_name, TRUE)
  goto_line(0, b_col)

  if compare(file_name, get_err_line()) = 0 then
    goto_line(start_line, 1)
    set_err_pointer()
    show_message()
  end if

end procedure

-- Ŀ
--  Assembliere 68k-Asm-Datei.                                  
-- 
procedure run_asm()

  if modified then
    save_file(file_name)
    stop = FALSE
  end if

  shell("ASM " & file_name, TRUE)
  goto_line(0, b_col)

end procedure

-- Ŀ
--  Starte ZBasic mit der Basic-Datei.                          
-- 
procedure run_bas()

  if modified then
    save_file(file_name)
    stop = FALSE
  end if

  shell("BASIC " & file_name, TRUE)
  goto_line(0, b_col)

end procedure

-- Ŀ
--  Starte GhostScript mit der PostScript-Datei.                
-- 
procedure run_ps()

  if modified then
    save_file(file_name)
    stop = FALSE
  end if

  shell("GHOST " & file_name, TRUE)
  goto_line(0, b_col)
  
end procedure

-- Ŀ
--  Starte Turbo-Pascal mit der Pascal-Datei.                   
-- 
procedure run_pas()

  atom pos
  sequence command
  
  if modified then
    save_file(file_name)
    stop = FALSE
  end if

  pos = find('.',file_name)
  command = "PASCAL " & file_name[1..pos-1]
  shell(command, TRUE)
  goto_line(0, b_col)
  
end procedure

-- Ŀ
--  Schliee das aktuelle Fenster                               
-- 
procedure quit_file()

  stop = delete_window()

  -- save_file(file_name)                        -- von mir deaktiviert !!!
                                                 -- es strt mich nur !
  --if modified and last_use() then
    --set_top_line(" Vorher sichern? >")
    --if find('j', key_gets("jn")) then
      --save_file(file_name)
    --end if
  --end if
    
  set_keywords()
  reset_top_line(FALSE)

end procedure

-- Ŀ
--  Benede die aktuelle Datei und ffne eine neue Datei.        
-- 
procedure new_file()

  sequence temp_name

  if modified and last_use() then
    set_top_line("")
    printf(SCREEN, "%s sichern? >", {file_name})
    if find('y', key_gets("yn")) then
      save_file(file_name)
    end if
  end if

  save_state()
  set_top_line(" Datei >")
  temp_name = delete_trailing_white(key_gets(""))

  if length(temp_name) != 0 then
    file_name = temp_name
    stop = TRUE
  end if

  reset_top_line(FALSE)

end procedure

-- Ŀ
--  ffne eine neue Datei                                       
-- 
procedure open_new_file()

  sequence temp_name

  set_top_line(" Datei >")
  temp_name = delete_trailing_white(key_gets(""))

  if length(temp_name) != 0 then
    clone_window()
    save_state()
    file_name = temp_name
    stop = TRUE
  end if

  reset_top_line(FALSE)

end procedure

-- Ŀ
--  Hebe das n-te Zeichen hervor.                               
-- 
procedure make_bold(sequence string,atom n)

  if n=1 then
    text_color(TOP_DIM_COL)
    puts(SCREEN, string[1])
  else
    text_color(TOP_TEXT_COL)
    puts(SCREEN, string[1..n-1])
    text_color(TOP_DIM_COL)
    puts(SCREEN, string[n])
  end if
  
  text_color(TOP_TEXT_COL)
  puts(SCREEN, string[n+1..length(string)])
  
end procedure

-- Ŀ
--  Zeige Hilfe-Datei auf dem Bildschirm aus "\EUDIR\DOC".      
-- 
procedure show_help(atom help)

  sequence answer
  atom hit

  self_command = getenv("EUDIR")
  
  if atom(self_command) then
    set_top_line(" <EUDIR> nicht gesetzt.")
  else
    self_command = self_command & "\\DOC\\"
    
    if help then
      hit = help
    else
      set_top_line("")
      if lang = ex then
        if hlp[1] = 0 then make_bold(" Ascii  ",2) end if
        if hlp[2] = 0 then make_bold("Editor  ",1) end if
        if hlp[3] = 0 then make_bold("Referenz  ",1) end if
        if hlp[4] = 0 then make_bold("Library  ",1) end if
        answer = key_gets("aerl") & ' '
        hit = find(answer[1], {'a', 'e', 'r', 'l'})
      elsif lang = asm then
        if hlp[5] = 0 then make_bold(" Asm  >",2) end if
        answer = key_gets("xxxxa") & ' '
        hit = find(answer[1], {'x', 'x', 'x', 'x', 'a'})
      elsif lang = bas then
        if hlp[6] = 0 then make_bold(" Basic  >",2) end if
        answer = key_gets("xxxxxb") & ' '
        hit = find(answer[1], {'x', 'x', 'x', 'x', 'x', 'b'})
      elsif lang = ps then
        if hlp[7] = 0 then make_bold(" Post  >",2) end if
        answer = key_gets("xxxxxxp") & ' '
        hit = find(answer[1], {'x', 'x', 'x', 'x', 'x', 'x', 'p'})
      end if
    end if

    if hit = 0 then
      normal_video()
      reset_top_line(FALSE)
    else
      clone_window()
      save_state()
      file_name = self_command & TITLE[hit]
      stop = TRUE
    end if
  end if

end procedure

-- Ŀ
--  Fhre ESC-Befehl aus.                                       
-- 
procedure get_escape()
    
  sequence command
  natural line

  cursor(ED_CURSOR)

  set_top_line("")

  make_bold(" Neu  ",2)
  make_bold("ffnen  ",1)
  make_bold("Sichern  ",1)
  make_bold("Quit  ",1)
  make_bold("Finden  ",1)
  make_bold("Ersetzen  ",1)
  
  if dot_e then
    make_bold("Run  ",1)
  end if
  
  make_bold("Dos  ",1)
  make_bold("Hilfe  ",1)
  text_color(TOP_TEXT_COL)
  puts(SCREEN, ">")
  command = key_gets("nosqferdh") & ' '
  
  if command[1] = 'n' then
    new_file()

  elsif command[1] = 'o' then
    open_new_file()

  elsif command[1] = 's' then
    save_file(file_name)
    stop = FALSE

  elsif command[1] = 'q' then
    quit_file()
    
  elsif command[1] = 'f' then
    replacing = FALSE
    searching = search(FALSE)

  elsif command[1] = 'e' then
    replacing = TRUE
    searching = search(FALSE)

  elsif command[1] = 'r' then
        if lang = ex then run_ex() end if
        if lang = asm then run_asm() end if
        if lang = bas then run_bas() end if
        if lang = ps then run_ps() end if
        if lang = pas then run_pas() end if

  elsif command[1] = 'd' then
    set_top_line("DOS-Befehl >")
    shell(key_gets(""), TRUE)
    goto_line(0, b_col)                          -- Aktualisiere die Anzeige

  elsif command[1] = 'h' then
    show_help(0)

  elsif command[1] >= '0' and command[1] <= '9' then
    line = numeric(command)
    normal_video()
    goto_line(line, 1)
    
    if not buffer_line(line) then
      set_top_line("")
      printf(SCREEN, "Zeilen 1..%d", length(buffer))
    end if
  
  end if

  reset_top_line(FALSE)

end procedure

-- Ŀ
--  Lsche eine Zeile aus dem Puffer und aktualisiere - falls   
--  ntig - die Anzeige.                                        
-- 
procedure delete_line(buffer_line dead_line)

  integer x
  set_modified()

  -- Bringe alle Zeilen nach der 'Tot'-Zeile um eins nach oben

  for i = dead_line to length(buffer)-1 do
    buffer[i] = buffer[i+1]
  end for

  buffer = buffer[1..length(buffer)-1]
  x = dead_line - b_line + s_line

  if window_line(x) then
    
    -- 'Tot'-Zeile ist auf dem Bildschirm in Zeile x
    
    ScrollUp(x, window_length)
    if length(buffer) - b_line >= window_length - s_line then
      
      -- Zeige neue Zeile ganz unten an
      
      DisplayLine(b_line + window_length - s_line, window_length, TRUE)
    end if
  end if

  if b_line > length(buffer) then
    arrow_up()
  else
    b_col = 1
    s_col = 1
  end if

  adding_to_kill = TRUE

end procedure

-- Ŀ
--  Lsche das Zeichen an der augenblicklichen Position.        
-- 
procedure delete_char()

  char dchar
  sequence head
  natural save_b_col

  set_modified()
  dchar = buffer[b_line][b_col]
  head = buffer[b_line][1..b_col - 1]

  if dchar = '\n' then
    if b_line < length(buffer) then

      -- Verbinde diese Zeile mit der nchsten und lsche die nchste
      
      buffer[b_line] = head & buffer[b_line+1]
      DisplayLine(b_line, s_line, FALSE)
      save_b_col = b_col
      delete_line(b_line + 1)

      for i = 1 to save_b_col - 1 do
        arrow_right()
      end for
    
    else
      
      if length(buffer[b_line]) = 1 then
        delete_line(b_line)
      else
        arrow_left()                             -- Zeile endet immer mit \n
      end if
    end if
  else
    buffer[b_line] = head & buffer[b_line][b_col+1..length(buffer[b_line])]
    
    if length(buffer[b_line]) = 0 then
      delete_line(b_line)
    else
      DisplayLine(b_line, s_line, FALSE)
      if b_col > length(buffer[b_line]) then
        arrow_left()
      end if
    end if
  end if

  adding_to_kill = TRUE

end procedure

-- Ŀ
--  Fge ein Zeichen in die aktuella Zeile an der aktuellen     
--  Position ein.                                               
-- 
procedure insert(char key, integer insert)
    
  --char dchar                                   -- von mir deaktiviert !!!
  sequence tail
  positive_int new_col

  set_modified()
  tail = buffer[b_line][b_col..length(buffer[b_line])]

  if key = CR or key = '\n' then
    
    -- Kurze die Zeile und erzeuge eine neue mit tail
    
    buffer[b_line] = buffer[b_line][1..b_col-1] & '\n'

    buffer = append(buffer, 0)                   -- Platz fr die neue Zeile

    for i = length(buffer)-1 to b_line+1 by -1 do
      buffer[i+1] = buffer[i]
    end for

    buffer[b_line+1] = tail                      -- Neue Zeile sichern

    if s_line = window_length then
      arrow_down()
      arrow_up()
    else
      ScrollDown(s_line+1, window_length)
    end if

    if window_length = 1 then
      arrow_down()
    else
      DisplayLine(b_line, s_line, FALSE)
      b_line = b_line + 1
      s_line = s_line + 1
      DisplayLine(b_line, s_line, FALSE)
    end if
    
    s_col = 1
    b_col = 1
  
  else
    
    if key = '\t' then
      new_col = tab(edit_tab_width, s_col)
    else
      new_col = s_col + 1
    end if
    
    if new_col > SCREEN_WIDTH then
      return
    else
      s_col = new_col
    end if
    
    if insert = 0 and b_col+1 <= length(buffer[b_line]) then
      tail = buffer[b_line][b_col+1..length(buffer[b_line])]
    end if
    
    buffer[b_line] = buffer[b_line][1..b_col-1] & key & tail
    
    DisplayLine(b_line, s_line, TRUE)
    b_col = b_col + 1
    
  end if

  set_position(s_line, s_col)

end procedure

-- Ŀ
--  Fge mehrer Zeichen an der aktuellen Position ein.          
-- 
procedure insert_string(sequence text)
    
  natural save_line, save_col

  save_line = b_line
  save_col = b_col

  for i = 1 to length(text) do
    
    if text[i] = CR or text[i] = '\n' then
      insert(text[i],1)
    else
      buffer[b_line] = buffer[b_line][1..b_col-1] & text[i] &
                       buffer[b_line][b_col..length(buffer[b_line])]
      b_col = b_col + 1
      if i = length(text) then
        DisplayLine(b_line, s_line, FALSE)
      end if
    end if
  
  end for
  
  goto_line(save_line, save_col)

end procedure

-- Ŀ
--  Expandierbare Worte und korrespondierender Text              
-- 
constant
expand_word = {"if", "for", "while", "elsif", "procedure", "type", "function"},
expand_text = {" then", "= to by do", " do", " then", "()", "()", "()"}

-- Ŀ
--  Prfe, ob ein Keyword vorliegt, das automatisch vervoll-    
--  stndigt werden kann.                                       
-- 
procedure try_auto_complete(char key)

  sequence word, this_line, white_space, leading_white, begin
  natural first_non_blank, wordnum

  if key = ' ' then
    insert(key,ins)
  end if

  this_line = buffer[b_line]
  white_space = this_line = ' ' or this_line = '\t'
  first_non_blank = find(0, white_space) -- am Ende befindet sich immer '\n'
  leading_white = this_line[1..first_non_blank - 1]

  if auto_complete and first_non_blank < b_col - 2 then
    if not find(0, white_space[b_col..length(white_space)-1]) then
      word = this_line[first_non_blank..b_col - 1 - (key = ' ')]
      wordnum = find(word, expand_word)

      if key = CR and compare(word, "else") = 0 then
        leading_white = leading_white & '\t'

      elsif wordnum > 0 then

        -- Expandierbare Worte (nur Worte auf dieser Zeile)

        begin = expand_text[wordnum] & CR & leading_white

        if compare(word, "elsif") = 0 then
          insert_string(begin & '\t')

        elsif find(word, {"function", "type"}) then
          insert_string(begin & CR & leading_white & "\treturn" & CR &
                        "end " & expand_word[wordnum])
        else
          insert_string(begin & '\t' & CR & leading_white &
                        "end " & expand_word[wordnum])
        end if

        delay(0.07)                              -- oder Beep ist zu kurz
      end if
    end if
  end if

  if key = CR then
    
    if b_col >= first_non_blank then
      buffer[b_line] = buffer[b_line][1..b_col-1] & leading_white &
      buffer[b_line][b_col..length(buffer[b_line])]
      insert(CR,1)
      skip_white()
    else
      insert(CR,1)
    end if
  
  end if

end procedure

-- Ŀ
--  Fge den Lsch-Puffer an der aktuellen Position ein. Dieser 
--  knnte eine Zeilen-Sequenz oder eine Zeichen-Sequenz sein.  
-- 
procedure insert_kill_buffer()

  if length(kill_buffer) = 0 then
    return
  end if

  if atom(kill_buffer[1]) then
    
    insert_string(kill_buffer)                   -- Zeichen-Sequenz einfgen
  else
    
    first_copy = 1                               -- Zeilen-Sequenz einfgen
    set_modified()
    buffer = buffer[1..b_line - 1] & kill_buffer &
             buffer[b_line..length(buffer)]
    DisplayWindow(b_line, s_line)
    b_col = 1
    s_col = 1
  end if

end procedure

-- Ŀ
--  Gib TRUE zurck, falls der Tastenbefehl ausgefhrt werden   
--  soll.                                                       
-- 
function good(extended_char key)

  if find(key, CONTROL_CHARS) then
    return TRUE
  elsif key >= ' ' and key <= 255 then
    return TRUE
  elsif key = '\t' or key = CR then
    return TRUE
  else
    return FALSE
  end if

end function

-- Ŀ
--  ffne bzw. schliee ein Hilfe-Fenster. Die Hilfstasten sind 
--  An- Aus-Schalter. Hilfefenster knnen ebenfalls mit ALT-Q   
--  oder ALT-B geschlossen werden.                              
-- 
procedure do_help(integer n)

  atom loc
  
  if hlp[n] = 0 then
    hlp[n] = 1
    show_help(n)
  else
    loc = match(lower(TITLE[n]),file_name)
    if loc > 1 and hlp[n] = 1 then
      hlp[n] = 0
      quit_file()
    end if
  end if

end procedure

-- Ŀ
--  Editiere die Datei, die sich augenblicklich im Puffer (d.h. 
--  auf dem Bildschirm) befindet.                               
-- 
procedure edit_file()

  extended_char key
  atom loc

  if length(buffer) > 0 then
    if start_line > 0 then
      if start_line > length(buffer) then
        start_line = length(buffer)
      end if
      goto_line(start_line, 1)
      set_err_pointer()
      show_message()
    end if
  end if

  -- Erhhe die Tastenwiederholungsrate:
  -- system("mode con rate=30 delay=2", 2)       -- von mir deaktiviert !!!
                                                 -- Ich habe dazu mein kleines
  cursor(ED_CURSOR)                              -- Assembler-Programm !
  stop = FALSE

  while not stop do

    key = next_key()
    
    if key = CONTROL_C then
      refresh_all_windows()
      goto_line(0, b_col)
    end if

    if find(key, CTRL_CHAR) then
      key = IBM_CHAR[find(key, CTRL_CHAR)]
    end if    
  
    if good(key) then                            -- Normale Taste

      if key = OVERRIDE then
        ins = 1 - ins

      elsif key = TAB and ins = 0 then
        tab_right()
      
      elsif key = ASC_HELP then
        do_help(1)

      elsif key = ED_HELP then
        do_help(2)

      elsif key = REF_HELP then
          do_help(3)

      elsif key = LIB_HELP then
          do_help(4)

      elsif key = ASM_HELP and lang = asm then
          do_help(5)

      elsif key = BAS_HELP and lang = bas then
          do_help(6)

      elsif key = PS_HELP and lang = ps then
          do_help(7)

      elsif key >= F1 and key <= F9 then
        if key < F1 + length(window_list) then
          switch_window(key - F1 + 1)
        end if

        adding_to_kill = FALSE

      elsif length(buffer) = 0 and key != ESCAPE then
  
        if key = INSERT or not find(key, CONTROL_CHARS) then
    
          buffer = {{'\n'}}
          b_line = 1
          b_col = 1
          s_line = 1
          s_col = 1
    
          if key = INSERT then
            insert_kill_buffer()
          else
            insert(key,ins)
          end if
    
          DisplayLine(1, 1, FALSE)
        end if

      elsif key = KILL_LINE then
        delete_line(b_line)
      
      elsif key = DELETE then
  
        if not adding_to_kill then
          kill_buffer = {buffer[b_line][b_col]}
        elsif sequence(kill_buffer[1]) then
          kill_buffer = {buffer[b_line][b_col]}
        else
          kill_buffer = append(kill_buffer, buffer[b_line][b_col])
        end if

        delete_char()

      elsif key = ALT_DELETE or key = CUT then
  
        if not adding_to_kill then
          kill_buffer = {buffer[b_line]}
  
      elsif atom(kill_buffer[1]) then
        kill_buffer = {buffer[b_line]}
      else
        kill_buffer = append(kill_buffer, buffer[b_line])
      end if
    
      delete_line(b_line)
      first_copy = 1
    
      elsif key = COPY then
        kill_buffer = {buffer[b_line]}
        first_copy = 1
  
      elsif key = ACCU_COPY then
        if first_copy = 1 then
          kill_buffer = {buffer[b_line]}
          first_copy = 0
        else
          kill_buffer = append(kill_buffer, buffer[b_line])
        end if
        add_queue(NEXT_LINE)
      
    else

      if key = SAVE then
        save_file(file_name)
        stop = FALSE

      elsif key = FIND then
        replacing = FALSE
        searching = search(FALSE)

      elsif key = FIND_NEW then
        replacing = FALSE
        searching = search(TRUE)

      elsif key = REPLACE then
        replacing = TRUE
        searching = search(FALSE)

      elsif key = REPLACE_NEW then
        replacing = TRUE
        searching = search(TRUE)

      elsif key = NEW then
        new_file()

      elsif key = HELP then
        show_help(0)

      elsif key = OPEN then
        open_new_file()

      elsif key = QUIT then     -- quit
        if hlp[1] = 0 and hlp[2] = 0 and hlp[3] = 0 and
          hlp[4] = 0 and hlp[5] = 0 and hlp[6] = 0 and
          hlp[7] = 0 then
          quit_file()
        else
          for i = 1 to 7 do
            if hlp[i] = 1 then
              loc = match(lower(TITLE[i]),file_name)
              if loc > 1 and hlp[i] = 1 then
                hlp[i] = 0
                quit_file()
              end if
            end if
          end for
        end if

      elsif key = DOS then
        set_top_line("DOS-Befehl >")
        shell(key_gets(""), TRUE)
        goto_line(0, b_col)

      elsif (key = RUN or key = WRUN) and dot_e then
        if lang = ex then run_ex() end if
        if lang = asm then run_asm() end if
        if lang = bas then run_bas() end if
        if lang = ps then run_ps() end if
        if lang = pas then run_pas() end if

      elsif key = PAGE_DOWN then
        page_down()

      elsif key = PAGE_UP then
        page_up()

      elsif key = ARROW_LEFT then
        arrow_left()

      elsif key = ARROW_RIGHT then
        arrow_right()

      elsif key = ALT_ARROW_LFT then
        previous_word()

      elsif key = ALT_ARROW_RGT then
        next_word()

      elsif key = ARROW_DOWN then
        arrow_down()

      elsif key = ARROW_UP then
        arrow_up()

      elsif key = ' ' then
        try_auto_complete(key)

      elsif key = INSERT then
        insert_kill_buffer()

      elsif key = BS then
        arrow_left()
        delete_char()

     elsif key = HOME then
       b_col = 1
       s_col = 1

     elsif key = END then
       goto_line(b_line, SCREEN_WIDTH)

     elsif key = ALT_HOME or key = ALT_PG_UP then
       goto_line(1, 1)

     elsif key = ALT_END or key = ALT_PG_DOWN then
       goto_line(length(buffer), SCREEN_WIDTH)

     elsif key = ESCAPE then

       get_escape()                              -- spezieller Befehl

     elsif key = CR then
    
       if searching then
         searching = search(TRUE)
         normal_video()
         searching = TRUE                        -- verhindert versehentliches
       else                                      -- Einfgen von >CR>
         try_auto_complete(key)
       end if

      else
        insert(key,ins)

    end if

    adding_to_kill = FALSE

      end if

      if key != CR and key != ESCAPE then
        searching = FALSE
      end if

      cursor(ED_CURSOR)
      set_position(s_line, s_col)
      show_row_col()

    else                                         -- nicht erlaubte Taste
      set_position(0, 1)
      set_top_line(" Keine Funktionstaste")      -- zeige Meldung
      delay(0.2)
      reset_top_line(TRUE)
    end if
  end while

end procedure

-- Ŀ
--   DIE HAUPT-PROZEDUR DES EDITORS  
-- 
procedure ed(sequence command)

  file_number file_no

  start_line = 0
  start_col = 0

  if length(command) >= 3 then
    file_name = lower(command[3])
  else
    file_name = get_err_line()
  end if

  if length(file_name) = 0 then
    
    puts(SCREEN, "Datei >")                      -- Dateinamen eingeben
    cursor(ED_CURSOR)
    file_name = key_gets("")
    puts(SCREEN, '\n')
  end if

  file_name = delete_trailing_white(file_name)

  if length(file_name) = 0 then
    abort(1)                                     -- Dateiname leer => Ende
  end if

  file_no = open(file_name, "r")

  -- deaktiviere multi_color & auto_complete fr nicht .e-Dateien
  
  multi_color = DO_COL_SNTX
  auto_complete = DO_AUTO_CMPL

  if not config[VC_COLOR] or config[VC_MODE] = 7 then
    multi_color = FALSE                          -- Monochromer Monitor
  end if

  file_name = file_name & ' '
  dot_e = FALSE
  
  for i = 1 to length(E_FILES) do
    if match(E_FILES[i] & ' ', file_name) then
      dot_e = TRUE
    end if
  end for
  
  for i = 1 to length(A_FILES) do
    if match(A_FILES[i] & ' ', file_name) then
      dot_e = TRUE
      lang = asm
      set_keywords()
    end if
  end for
  
  for i = 1 to length(B_FILES) do
    if match(B_FILES[i] & ' ', file_name) then
      dot_e = TRUE
      lang = bas
      set_keywords()
    end if
  end for
  
  for i = 1 to length(P_FILES) do
    if match(P_FILES[i] & ' ', file_name) then
      dot_e = TRUE
      lang = ps
      set_keywords()
    end if
  end for
  
  for i = 1 to length(T_FILES) do
    if match(T_FILES[i] & ' ', file_name) then
      dot_e = TRUE
      lang = pas
      set_keywords()
    end if
  end for
  
  if not dot_e then
    multi_color = FALSE
    auto_complete = FALSE
  end if

  -- benutze PROG_INDENT Einzuf fr Euphoria & andere Sprachen:
  
  edit_tab_width = NORM_TAB

  for i = 1 to length(E_FILES) do
    if match(E_FILES[i] & ' ', file_name) then
      edit_tab_width = PROG_INDENT
      exit
    end if
  end for

  file_name = file_name[1..length(file_name)-1]  -- lsche ' '
  
  if multi_color then
    init_class()
  end if

  adding_to_kill = FALSE
  clear_modified()
  buffer_version = 0
  control_chars = FALSE
  wrap(0)
  new_buffer()
  s_line = 1
  s_col = 1
  b_line = 1
  b_col = 1
  save_state()

  set_f_line(window_number)
  normal_video()
  
  if file_no = -1 then
    ClearWindow()
  else
    set_position(1, 1)
    cursor(NO_CURSOR)
    read_file(file_no)
    close(file_no)
  end if
  
  set_position(1, 1)
  edit_file()

end procedure

-- Ŀ
--   DAS HAUPT-PROGRAMM VON ED.EX  
-- 
procedure ed_main()

  -- Starten und Verlassen des Editors
  
  sequence cl, pal

  ins = 1
  hlp = {0, 0, 0, 0, 0, 0, 0}
  first_copy = 1
  config = video_config()

  if config[VC_XPIXELS] > 0 then
    if graphics_mode(3) then
    end if
    config = video_config()
  end if

  if config[VC_LINES] != INITIAL_LINES then
    screen_length = text_rows(INITIAL_LINES)
    config = video_config()
  end if

  screen_length = config[VC_LINES]
  window_length = screen_length - 1
  pal = palette(BLUE,{0,23,35})
  cl = command_line()

  while length(window_list) > 0 do
    ed(cl)
    cl = {"ex", "ed.ex", file_name}
  end while

  -- Den Editor verlassen

  if screen_length != FINAL_LINES then
    screen_length = text_rows(FINAL_LINES)
  end if

  cursor(UNDERLINE_CURSOR)
  bk_color(BLACK)
  text_color(BLACK)
  position(screen_length, 1)
  puts(SCREEN, BLANK_LINE)
  position(screen_length, 1)
  text_color(WHITE)
  puts(SCREEN, " \n")

end procedure

--include syncolor.e                             -- von mir deaktiviert !!!
                                                 -- erscheint bei mir frher !
ed_main()

clear_screen()
abort(0) 

-- 
